/*
** PlayTempFile.c for Gmurf in ~/Gmurf/TempFile/
** 
** Made by 
** Login   <ahes@ker-ys.epita.fr>
** 
** Started on  Fri Mar  5 19:20:15 1999 
** Last update Fri Mar 19 11:57:56 1999 Rmi Coupet
*/
#include <stdio.h>
#include <unistd.h>
#include "Errors.h"
#include "Fct_Sys.h"
#include "Constants.h"
#include "PlayTempFile.h"


void	affiche_per100(nb_unit, length, ww)
Wavwin	*ww ;
off_t	nb_unit;
off_t	length;     
{
  float	per100;
 
  per100 = ((double) nb_unit) / (double) (length);
#ifdef GTK_GMURF
  gtk_progress_set_percentage(GTK_PROGRESS(ww->progress_bar), per100) ;
  while(gtk_events_pending())
    gtk_main_iteration();
#else
#ifdef TEXT_MSG
  printf("%1.1f%%, pos = %d\n", per100 * 100, 2 * (int) (nb_unit * sizeof(short int)));
#endif
#endif
}

/*
** set_buffer: modifie le buffer en fonction des option donnees
*/
void		set_buffer(buffer, nb, playmode)
short int	*buffer;
size_t		nb;
t_playmode	*playmode;
{
  long int	cpt;
  
  if ((playmode->chanels == 0) || (playmode->chanels == 1))
    for (cpt = 0; cpt < nb; cpt++)
      {
	if (playmode->chanels + (cpt % 2) == 1)
	  buffer[cpt] *= 0;
	else
	  buffer[cpt] *= 1;
      }
}

/*
** init_play_file: initialise le player de fichier temporaire
*/
int	init_play_file(curr_pos, file, pos, length)
off_t	*curr_pos;
int	file;
off_t	pos;
off_t	*length;
{
  *curr_pos = lseek(file, pos * 4, SEEK_SET);
  if (*curr_pos == -1)
    {
#ifdef TEXT_MSG
      printf("%s\n", BAD_SEEK);
#endif
      return (-1);
    }
  *curr_pos /= 4;
  if (*length == 0)        
    *length = (give_file_size(file) / 4) - pos; 
  return (0);
}

/*
** play_file: lit les donnees et les joue sur le dsp
*/
void		play_file(file, nb, dsp_file, playmode, pos)
int		file;
size_t		nb;
int		dsp_file;
t_playmode	playmode;
size_t		*pos;
{
  short int	buffer[BUFFER_SIZE * 2]; /* this buffer contain BUFFER_SIZE sound units */

  lseek(file, *pos * 2 * sizeof(short int), SEEK_SET);
  read(file, &buffer, 2 * nb * sizeof(short  int));
  set_buffer(buffer, 2 * nb, playmode);
  write(dsp_file, &buffer, 2 * nb * sizeof(short int));
  *pos += nb;
}

void		get_positions(curr_pos, length, temp_size, select, part2play, pos, _length)
size_t		*curr_pos;
size_t		*length;
size_t		temp_size;
t_select	*select;
int		part2play;
size_t		pos;
size_t		_length;
{
  if (select->is_selected == 0) 
    {
      *curr_pos = pos;
      *length   = _length;
    }
  else
    {
      *curr_pos = (select->reverse == 0 ? select->begin  : 
		  (part2play == 1 ? select->begin + select->length : 0));
      *length   = (select->reverse == 0 ? select->length : 
		  (part2play == 1 ? (temp_size / 4) - (select->begin + select->length) : select->begin));
    }
}

/*
** play_temp_file: joue un fichier temporaire de la position donnee (en unite de son)
**		   sur la longeur donne (en unites de son) sur le dsp donne et dans le
**		   mode donne
*/
int		play_temp_file(file, dsp_file, pos, _length, playmode, ww, select)
int		file;
int		dsp_file;
off_t		pos;
off_t		_length;
t_playmode	*playmode;
Wavwin		*ww ;
t_select	*select;
{
  size_t	nb_unit; 
  size_t	curr_pos; 
  size_t	total_length;
  size_t	nb_unit_total;
  size_t	length; 
  size_t	nb; 
  int		part2play;	/* the number of part to play in the file */

  part2play = (select->is_selected == 0 ? 1 : select->reverse + 1);
  total_length = (select->is_selected == 0 ? _length : 
		  (select->reverse == 0 ? select->length : (ww->tempgmurf->temp_size / 4) - select->length));
  nb_unit_total = 0;
  do
    {
      get_positions(&curr_pos, &length, ww->tempgmurf->temp_size, select, part2play, pos, _length);
      nb_unit = 0;
      while(nb_unit < length)
	{
	  nb = (nb_unit + BUFFER_SIZE < length ? BUFFER_SIZE : length - nb_unit);
	  play_file(file, nb, dsp_file, playmode, &curr_pos);
	  affiche_per100(nb_unit_total, total_length, ww);
	  nb_unit += nb;
	  nb_unit_total += nb;
	}
      
      part2play--;
    } while (part2play > 0);
  gtk_progress_bar_update(GTK_PROGRESS_BAR(ww->progress_bar), 0.0) ;

  return (0);
}







