#include <gtk/gtk.h>
#include <stdio.h>
#define IWIDTH 300
#define IHEIGHT 100

static GdkPixmap *pixmap = NULL;

static gint configure_event (GtkWidget *widget, GdkEventConfigure *event)
{
  if (pixmap)
    gdk_pixmap_unref(pixmap);
  pixmap = gdk_pixmap_new(widget->window,
			  widget->allocation.width,
			  widget->allocation.height,
			  -1);
  draw_brush(widget) ;
  
  return TRUE;
}



static gint button_press_event(GtkWidget *widget, GdkEventButton *event)
{
  //  if (event->button == 1 && pixmap != NULL)
  // draw_brush(widget, event->x, event->y);
  
  return TRUE;
}


static gint motion_notify_event(widget,
			event,
			data)
     GtkWidget		*widget ;
     GdkEventMotion	*event ;
     gpointer		data ;
{
   int x, y;
   GdkModifierType state;
   
   if (event->is_hint)
     gdk_window_get_pointer(event->window, &x, &y, &state);
   else
     {
       x = event->x;
       y = event->y;
       state = event->state;
     }
   
   if (state & GDK_BUTTON1_MASK && pixmap != NULL)
     draw_brush(widget);
   
  return TRUE;
}


static gint expose_event (GtkWidget *widget, GdkEventExpose *event)
{
    gdk_draw_pixmap(widget->window, 
  		  widget->style->black_gc, 
  		  pixmap, 
  		  event->area.x, event->area.y, 
  		  event->area.x, event->area.y, 
  		  event->area.width, event->area.height); 
  
  return FALSE;
}


gint draw_brush (GtkWidget *widget)
{
  GdkRectangle update_rect;
  int i;
  int iwidth, iheight ;

  iwidth = widget->allocation.width ;
  iheight = widget->allocation.height ;
  update_rect.x = 0;
  update_rect.y = 0;
  update_rect.width = iwidth;
  update_rect.height = iheight;
 
    gdk_draw_rectangle (pixmap,
		      widget->style->white_gc,
		      TRUE,
		      update_rect.x, update_rect.y,
		      update_rect.width, update_rect.height);

  for (i=0; i<iwidth; i++){
    gdk_draw_line (pixmap,
		   widget->style->black_gc,
		   i, iheight/2, i,
		   iheight/2 + pow(-1, rand()%10 ) * (rand() % (iheight/2 -1)));
  }

  
  gtk_widget_draw (widget, &update_rect);
  return TRUE;
  
}


int main (int argc, char * argv[]) 
{
  GtkWidget *drawing_area, *window, *frame;
  gtk_init (&argc, &argv);

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL); 
  frame = gtk_frame_new("essai");
  gtk_widget_show(frame) ;
  drawing_area = gtk_drawing_area_new();
  gtk_drawing_area_size(GTK_DRAWING_AREA(drawing_area), IWIDTH, IHEIGHT);
  
  gtk_signal_connect(GTK_OBJECT (drawing_area), "expose_event",
		     (GtkSignalFunc) expose_event, NULL);
  gtk_signal_connect(GTK_OBJECT(drawing_area),"configure_event",
		     (GtkSignalFunc) configure_event, NULL);
  gtk_signal_connect(GTK_OBJECT (drawing_area), "motion_notify_event",
		     (GtkSignalFunc) motion_notify_event, NULL);
  gtk_signal_connect(GTK_OBJECT (drawing_area), "button_press_event",
		     (GtkSignalFunc) button_press_event, NULL);
  
  gtk_widget_set_events(drawing_area, GDK_EXPOSURE_MASK
			| GDK_LEAVE_NOTIFY_MASK
			| GDK_BUTTON_PRESS_MASK
			| GDK_POINTER_MOTION_MASK
			| GDK_POINTER_MOTION_HINT_MASK);

  //  gtk_timeout_add (40, draw_brush,(GtkWidget *) drawing_area);
  
  gtk_container_add(GTK_CONTAINER (frame), drawing_area);
  gtk_container_add(GTK_CONTAINER (window), frame);
  gtk_widget_show(drawing_area);
  gtk_widget_show(window);
  gtk_main();

  return 0;
}









